package de.fhdw.gaming.memory.impl;

import java.util.Optional;

import de.fhdw.gaming.core.domain.Move;
import de.fhdw.gaming.memory.Pair;

/**
 * .
 */
public class MemoryPairImpl implements Pair<Optional<Double>, Move<?, ?>> {

    
    /**
     * .
     */
    private Optional<Double> outcome = null;
    
    /**
     * .
     */
    private Move<?, ?> myMove = null;
    
    /**
    * .
    */
   private Move<?, ?> opponentMove = null;

    /**
     * .
     * @param outcome
     * @param myMove
     * @param opponentMove
     */
    public MemoryPairImpl(Optional<Double> outcome, Move<?, ?> myMove, Move<?, ?> opponentMove) {
        this.outcome = outcome;
        this.myMove = myMove;
        this.opponentMove = opponentMove;
    }
    
    /**
     * .
     */
    @Override
    public Optional<Double> getOutcome() {
        return outcome;
    }
    
    /**
     * .
     */
    @Override
    public Move<?, ?> getMyMove() {
        return myMove;
    }
    
    /**
     * .
     */
    @Override
    public Move<?, ?> getOpponentMove() {
        return opponentMove;
    }
    
    /**
     * .
     */
    @Override
    public String toString() {
        final StringBuilder result = new StringBuilder();

        result.append("Outcome: ").append(outcome != null ? outcome.toString() : "null");
        result.append(", Move: ").append(myMove != null ? myMove.toString() : "null");
        result.append(", OppMove: ").append(opponentMove != null ? opponentMove.toString() : "null.");

        return result.toString();
    }

    
}
